// include the library construction header file

//#include <winuser.h>
#include <windows.h> 
#include <malloc.h>
#include <stdio.h>
#include <wininet.h> 


#include "pro_ext.h"
#include "library.h"


int __extern_YToIndex(FillGradient loFG, int liY, int liX)
   {
   return (liX-1)*loFG->_ByteCount+1+(loFG->biHeight-liY)*(loFG->biWidth*loFG->_ByteCount+loFG->_Delta);
   }


// zahj naten URL
void FAR __extern_FillGradient(ParamBlk FAR *parm)
   {
   #define p0 (parm->p[0].val)

   BYTE lir,lig,lib,lird,ligd,libd;
   int lnY1,lnY2,lnX1,lnX2,lii,liIndex,liy;

   _HLock(p0.ev_handle);
   FillGradient loFG = (FillGradient) _HandToPtr(parm->p[0].val.ev_handle);
   _HUnLock(p0.ev_handle);


   int liHeight=loFG->Y2-loFG->Y1+1;
   int liWidth=loFG->X2-loFG->X1+1;

   lird = loFG->RGB2.r-loFG->RGB1.r;
   ligd = loFG->RGB2.g-loFG->RGB1.g;
   libd = loFG->RGB2.b-loFG->RGB1.b;


   if (loFG->Type==_FG_DIAGONAL)
      {
      //_BreakPoint();
      liIndex=__extern_YToIndex(loFG,loFG->Y1,loFG->X1)-1;
      *(loFG->Data+liIndex)=loFG->RGB1.b;
      *(loFG->Data+liIndex+1)=loFG->RGB1.g;
      *(loFG->Data+liIndex+2)=loFG->RGB1.r;

      lnX1=lnY1=lnX2=lnY2=0;
      while( lnX1 < liWidth && lnY1 < liHeight )
        {
        if (lnY1 < liHeight-1)
           lnY1++;
        else
           lnX1++;

        if (lnX2 < liWidth-1)
           lnX2++;
        else
           lnY2++;

        lii = lnX1+lnY1;
        lir = loFG->RGB1.r + (lii * (lird) / (liWidth+liHeight));
        lig = loFG->RGB1.g + (lii * (ligd) / (liWidth+liHeight));
        lib = loFG->RGB1.b + (lii * (libd) / (liWidth+liHeight));

        for (lii=lnY2; lii<=lnY1;lii++)
            {
            liIndex=__extern_YToIndex(loFG,loFG->Y1+lii,loFG->X1+lnX1+(lnY1-lii))-1;
            *(loFG->Data+liIndex)=lib;
            *(loFG->Data+liIndex+1)=lig;
            *(loFG->Data+liIndex+2)=lir;
            }

        }

      }

   if (loFG->Type==_FG_VERTICAL)
      {
//_BreakPoint();
      LPBYTE RowBuffer = (LPBYTE)malloc( liWidth*loFG->_ByteCount);
      for (lii=0;lii<liWidth;lii++)
          {
          *(RowBuffer+lii*loFG->_ByteCount+2) = loFG->RGB1.r + (lii * (lird) / liWidth);
          *(RowBuffer+lii*loFG->_ByteCount+1) = loFG->RGB1.g + (lii * (ligd) / liWidth);
          *(RowBuffer+lii*loFG->_ByteCount)   = loFG->RGB1.b + (lii * (libd) / liWidth);
          }

      for (lii=0;lii<liHeight;lii++)
          {
          liIndex=__extern_YToIndex(loFG,loFG->Y1+lii,loFG->X1)-1;
          memcpy((loFG->Data+liIndex),RowBuffer,liWidth*loFG->_ByteCount);
          }
      free(RowBuffer);

/*      for (lii=0;lii<liHeight;lii++)
          {
          for (liy=0;liy<liWidth;liy++)
              {
              liIndex=__extern_YToIndex(loFG,loFG->Y1+lii,loFG->X1+liy)-1;
              *(loFG->Data+liIndex)=loFG->RGB1.b + (liy * (libd) / liWidth);
              *(loFG->Data+liIndex+1)=loFG->RGB1.g + (liy * (ligd) / liWidth);
              *(loFG->Data+liIndex+2)=loFG->RGB1.r + (liy * (lird) / liWidth);
              }
          }
*/
      }

   if (loFG->Type==_FG_HORIZONTAL)
      {
//_BreakPoint();

      LPBYTE RowBuffer = (LPBYTE)malloc( liWidth*loFG->_ByteCount);

      for (lii=0;lii<liHeight;lii++)
          {
          lir = loFG->RGB1.r + (lii * (lird) / liHeight);
          lig = loFG->RGB1.g + (lii * (ligd) / liHeight);
          lib = loFG->RGB1.b + (lii * (libd) / liHeight);

          *(RowBuffer+2) = lir;
          *(RowBuffer+1) = lig;
          *(RowBuffer)   = lib;

          for (liy=1;liy<liWidth;liy++)
              {
              memcpy((RowBuffer+liy*loFG->_ByteCount),RowBuffer,loFG->_ByteCount);
              }

          liIndex=__extern_YToIndex(loFG,loFG->Y1+lii,loFG->X1)-1;
          memcpy((loFG->Data+liIndex),RowBuffer,liWidth*loFG->_ByteCount);
          }
      free(RowBuffer);
      }

   }





FoxInfo myFoxInfo[] = {
	{"vfpbmp_fillgradient",(FPFI) __extern_FillGradient, 1,"C"},
};



extern "C" 
{
	// the FoxTable structure
	FoxTable _FoxTable = {
		(FoxTable  *) 0, sizeof(myFoxInfo)/sizeof(FoxInfo), myFoxInfo
	};

}


